<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: Level</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: Level</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>Level<span class="signature">()</span><span class="type-signature"></span></h2>
        
            <div class="class-description"><p>Creates elements for level editing.</p></div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="Level"><span class="type-signature"></span>new Level<span class="signature">()</span><span class="type-signature"></span></h4>
    

    















<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line4">line 4</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id="chapter"><span class="type-signature"></span>chapter<span class="type-signature"></span></h4>




<div class="description">
    <p>chapter schema</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line14">line 14</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="cue"><span class="type-signature"></span>cue<span class="type-signature"></span></h4>




<div class="description">
    <p>cue schema</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line149">line 149</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="cuelist"><span class="type-signature"></span>cuelist<span class="type-signature"></span></h4>




<div class="description">
    <p>store cues to allow for autocomplete</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line214">line 214</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="level"><span class="type-signature"></span>level<span class="type-signature"></span></h4>




<div class="description">
    <p>level schema</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line22">line 22</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="plugins"><span class="type-signature"></span>plugins<span class="type-signature"></span></h4>




<div class="description">
    <p>store plugins to embedd their cue properties</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line211">line 211</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="append"><span class="type-signature"></span>append<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>add plugins cue properties and definitions to level schema</p>
<p>replace previous cue properties and definitions</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line237">line 237</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="getSchema"><span class="type-signature"></span>getSchema<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>get current cue schema</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line261">line 261</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="openDocument"><span class="type-signature"></span>openDocument<span class="signature">(data, is_new<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>open leveleditor in main window</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>json formatted level data</p>
                <h6>Properties</h6>
                

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>name var is required</p></td>
        </tr>

    
    </tbody>
</table>

            </td>
        </tr>

    

        <tr>
            
                <td class="name"><code>is_new</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last"><p>if content is already stored in database.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line272">line 272</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="routeOptionsMenu"><span class="type-signature"></span>routeOptionsMenu<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>create click routings for level options</p>
<ul>
<li>launch: launch a session based on the selected level</li>
<li>control_layout: switch to cue control editing page</li>
<li>config: switch to level config editor</li>
<li>table: switch to table view of level elements</li>
<li>graph: switch to node graphical view of level elements</li>
</ul>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line344">line 344</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="showConfig"><span class="type-signature"></span>showConfig<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>show config of the currently open level</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line379">line 379</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="showControlLayout"><span class="type-signature"></span>showControlLayout<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>show control page layout of the currently open level</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="editor_level_collection.js.html">editor/level_collection.js</a>, <a href="editor_level_collection.js.html#line387">line 387</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="Collection.html">Collection</a></li><li><a href="Control.html">Control</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Level.html">Level</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Routing.html">Routing</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Sessions.html">Sessions</a></li></ul><h3>Namespaces</h3><ul><li><a href="socket.html">socket</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#namespace">namespace</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#routing">routing</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:22:15 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>